"use strict";

/**
 * 设备管理模块
 */
var DeviceManager = {
    /**
     * 设备类型 108， 116， 默认108
     */
    __deviceCode: undefined,

    setDeviceCode: function setDeviceCode(deviceCode) {
        this.__deviceCode = deviceCode;
    },

    getDeviceCode: function getDeviceCode() {
        if (this.__deviceCode == undefined) {
            return dmx108_protocol.DEVICE_CODE_ENUM.DMX108;
        } else {
            return this.__deviceCode;
        }
    },

    /**
     * 设备列表
     * [{
     *      id: 0,
     *      name: '会议室',
     *      version: '1.0.0',
     *      ip: '192.168.0.1',
     *      state: 1 // 1在线，0离线 
     * }]
     */
    __deviceList: [],

    setDeviceList: function setDeviceList(deviceList) {
        this.__deviceList = deviceList;
    },

    getDeviceList: function getDeviceList() {
        return this.__deviceList;
    }
};