"use strict";

// util.setHtmlFontSize(window);

// window.onresize = function() {
//     util.setHtmlFontSize(window);
// };

var SHORT_REM = 37.5;
var setHtmlFontSize = function setHtmlFontSize() {
    // let scale = 1; //暂不支持。非全屏模式，根据状态栏大小设置缩放比例
    //适配以界面短边完全显示为准。(短边长度==37.5rem)(short_px_expected==37.5rem)
    var screenWidth = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
    var screenHeight = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    var short_px_expected = Math.min(screenWidth, screenHeight);
    var remPx = short_px_expected / SHORT_REM; //(1)rem == (remPx)px
    window.document.documentElement.style.fontSize = remPx + "px";
    console.log(" ====== html fontSize (rem) = " + window.document.documentElement.style.fontSize);
};
setHtmlFontSize();

//校准rem，测试显示部分手机rem单位的实际大小不符合预期。校准参考元素(id="REM_ADJUST")
var adjustRem = function adjustRem() {
    //适配以界面短边完全显示为准。(短边长度==37.5rem)(short_px_expected==37.5rem)
    var screenWidth = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
    var screenHeight = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    var short_px_expected = Math.min(screenWidth, screenHeight);

    var element_REM_ADJUST = document.getElementById("REM_ADJUST");
    var short_px_real = Math.min(element_REM_ADJUST.offsetWidth, element_REM_ADJUST.offsetHeight);
    console.log(" ================ short_px_expected=" + short_px_expected);
    console.log(" ================ short_px_real=" + short_px_real);
    if (Math.abs(short_px_real - short_px_expected) > 1) {
        var remPx = short_px_expected / SHORT_REM / (short_px_real / short_px_expected);
        window.document.documentElement.style.fontSize = remPx.toFixed(2) + "px";
        console.log(" ====== after adjust rem, html fontSize (rem) = " + window.document.documentElement.style.fontSize);
    }
};
// setTimeout(adjustRem, 3000);

window.onload = function () {
    // setTimeout(adjustRem, 3000);
    adjustRem();
    Origami.fastclick(document.body);
};

window.onresize = function () {
    // setTimeout(adjustRem, 3000);
    adjustRem();
};

//自定义 ngTouch:ngTouchstart,ngTouchmove,ngTouchend
angular.module("ngTouch", []).directive("ngTouchstart", function () {
    return {
        controller: function controller($scope, $element, $attrs) {
            $element.bind('touchstart', onTouchStart);

            function onTouchStart(event) {
                var method = $element.attr('ng-touchstart');
                $scope.$event = event;
                $scope.$apply(method);
            };
        }
    };
}).directive("ngTouchmove", function () {
    return {
        controller: function controller($scope, $element, $attrs) {
            $element.bind('touchstart', onTouchStart);

            function onTouchStart(event) {
                event.preventDefault();
                $element.bind('touchmove', onTouchMove);
                $element.bind('touchend', onTouchEnd);
            };

            function onTouchMove(event) {
                var method = $element.attr('ng-touchmove');
                $scope.$event = event;
                $scope.$apply(method);
            };

            function onTouchEnd(event) {
                event.preventDefault();
                $element.unbind('touchmove', onTouchMove);
                $element.unbind('touchend', onTouchEnd);
            };
        }
    };
}).directive("ngTouchend", function () {
    return {
        controller: function controller($scope, $element, $attrs) {
            $element.bind('touchend', onTouchEnd);

            function onTouchEnd(event) {
                var method = $element.attr('ng-touchend');
                $scope.$event = event;
                $scope.$apply(method);
            };
        }
    };
});

var app_dmx108 = angular.module("app_dmx108", ["ngTouch"]);
app_dmx108.controller("app_dmx108Ctrl", function ($scope) {
    // 首先初始化数据
    dmx108_data.init();

    //设置语言，优先处理
    $scope.system_setLanguage = function (isEnglish) {
        if (isEnglish) dmx108_ui = angular.extend(dmx108_ui, dmx108_ui_english);else dmx108_ui = angular.extend(dmx108_ui, dmx108_ui_chinese);
        $scope.dmx108_ui = dmx108_ui;
        $scope.system_isEnglish = isEnglish;
        localStorage.setItem($scope.STORAGE_KEY_system_isEnglish, $scope.system_isEnglish ? "true" : "false"); //localStorage 参数类型是 string
    };
    $scope.STORAGE_KEY_system_isEnglish = "STORAGE_KEY_system_isEnglish";
    $scope.system_isEnglish = localStorage.getItem($scope.STORAGE_KEY_system_isEnglish) == "true"; //localStorage 参数类型是 string
    $scope.system_setLanguage($scope.system_isEnglish);

    // ================

    $scope.tab_enum_menu = "tab_menu";
    $scope.tab_enum_volume = "tab_volume";
    $scope.tab_enum_scene = "tab_scene";
    $scope.tab_enum_device = "tab_device";
    $scope.tab_enum_setting = "tab_setting";
    $scope.tab_enum_mix = "tab_mix";
    $scope.tab_curEnum = $scope.tab_enum_volume;

    $scope.tab_updateData = function () {
        $scope.tab_menuList = [];
        $scope.tab_menuList.push({
            enumStr: $scope.tab_enum_menu
        });
        $scope.tab_menuList.push({
            enumStr: $scope.tab_enum_volume,
            name: dmx108_ui.MENU_VOLUME,
            isShow: true
        });
        $scope.tab_menuList.push({
            enumStr: $scope.tab_enum_scene,
            name: dmx108_ui.MENU_SCENE,
            isShow: true
        });
        $scope.tab_menuList.push({
            enumStr: $scope.tab_enum_device,
            name: dmx108_ui.MENU_DEVICE,
            isShow: true
        });
        $scope.tab_menuList.push({
            enumStr: $scope.tab_enum_setting,
            name: dmx108_ui.MENU_SETTING,
            isShow: true
        });
        $scope.tab_menuList.push({
            enumStr: $scope.tab_enum_mix
            // name: enumStr,
            // isShow: true,
        });
        $scope.menu_onClick_item = function (enumStr) {
            $scope.tab_curEnum = enumStr;
        };
        $scope.menu_onClick_back = function () {
            $scope.tab_curEnum = $scope.tab_enum_menu;
        };
    };
    $scope.tab_updateData();

    // ===============================================================================
    // ========== 联机界面 ==========================================================
    // ===============================================================================

    $scope.device_updateData = function () {
        $scope.device_list = dmx108_dataApi.getDeviceList(); //设备列表，搜索设备完成后需要更新
        $scope.device_curIndex = -1;
        $scope.device_onClick_item = function (index) {
            //联机成功后需要更新 $scope.device_isOnline
            $scope.device_curIndex = $scope.device_curIndex == index ? -1 : index;
            if ($scope.device_list[index].state == 1) return;
            var ip = $scope.device_list[index].ip;
            navigator.notification.confirm(dmx108_ui.PROMPT_DEVICE_ASK_CONNECT + $scope.device_list[index].name.trim() + dmx108_ui.CHAR_QUESTION_MARK, function (selectIndex) {
                if (selectIndex == 1) {
                    $scope.connectSocket(ip, index);
                }
            }, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
        };
        $scope.device_isLogin = dmx108_data.getUserLoginInfo().isLogin;
        $scope.device_onClick_logout = function () {
            navigator.notification.confirm(dmx108_ui.PROMPT_ASK_QUIT_ACCOUNT, function (selectIndex) {
                if (selectIndex == 1) {
                    $scope.userLogout();
                }
            }, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
        };
    };

    $scope.device_channelNum_is8Ch = true; //设备类型，搜索设备列表时使用此参数
    $scope.device_onClick_model = function () {
        if ($scope.device_isOnline) {
            window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_DEVICE_CAN_CHANGE_DEVICE_AFTER_DISCONNECT);
        } else {
            $scope.device_channelNum_is8Ch = !$scope.device_channelNum_is8Ch;
            if ($scope.device_channelNum_is8Ch) {
                DeviceManager.setDeviceCode(dmx108_protocol.DEVICE_CODE_ENUM.DMX108);
            } else {
                DeviceManager.setDeviceCode(dmx108_protocol.DEVICE_CODE_ENUM.DMX116);
            }
        }
    };

    $scope.device_isOnline = false;
    $scope.device_onClick_online = function () {
        //联机成功后需要更新 $scope.device_isOnline
        if ($scope.device_isOnline) {
            navigator.notification.confirm(dmx108_ui.PROMPT_DEVICE_ASK_DISCONNECT, function (selectIndex) {
                if (selectIndex == 1) {
                    console.log('disconnectDevice 5');
                    $scope.disconnectDevice();
                }
            }, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
        }
    };

    $scope.device_onClick_search = function () {
        $scope.searchDevice();
    };

    // ===============================================================================
    // ========== 场景界面 ==========================================================
    // ===============================================================================

    $scope.scene_updateData = function () {
        $scope.scene_list = dmx108_dataApi.getSceneList();
        $scope.scene_curIndex = -1;
        $scope.scene_onClick_item = function (index) {
            $scope.scene_curIndex = $scope.scene_curIndex == index ? -1 : index;
            if ($scope.scene_list[index].isPreset == 0) return;
            navigator.notification.confirm(dmx108_ui.PROMPT_SCENE_ASK_LOAD + $scope.scene_list[index].name + dmx108_ui.CHAR_QUESTION_MARK, function (selectIndex) {
                if (selectIndex == 1) {
                    $scope.loadScene(index + 1);
                }
            }, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
        };
    };
    $scope.scene_updateData();

    // ===============================================================================
    // ========== 音量界面 ==========================================================
    // ===============================================================================

    $scope.volume_updateData = function () {
        //IOS版本div的滚动和input-range的滑动会冲突，所以input-range触摸开始时禁用div滚动，结束时还原
        $scope.volume_touchStart = function () {
            // console.log(document.getElementsByClassName("volume-list")[0].style);
            $scope.volume_listStyle = {
                overflowX: "hidden"
            };
        };
        $scope.volume_touchEnd = function () {
            $scope.volume_listStyle = {
                overflowX: "scroll"
            };
        };

        $scope.volume_curScene = dmx108_dataApi.getCurScene();
        $scope.volume_list = dmx108_dataApi.getVolumeInfoList();
        $scope.volume_list.forEach(function (item, index) {
            item.updateRange = function () {
                var MIN_THUMB_BOTTOM_REM = 0.5;
                var MAX_THUMB_BOTTOM_REM = 13.0;
                var percent = this.volumeIndex / (this.list.length - 1);
                this.thumbStyle = {
                    bottom: MIN_THUMB_BOTTOM_REM + MAX_THUMB_BOTTOM_REM * percent + "rem"
                };
            };
            item.updateRange();
        });
    };
    $scope.volume_updateData();

    $scope.volume_isCurInput = true;
    $scope.volume_onClick_switch = function () {
        $scope.volume_isCurInput = !$scope.volume_isCurInput;
    };

    $scope.volume_updateElectric = function (channelIndex, electricPercent) {
        var volume = $scope.volume_list[channelIndex];
        var percent = electricPercent;
        var MAX_HEIGHT_REM = 18 * 0.9;
        volume.electricStyle = {
            clip: "rect(0, 0.9rem, " + MAX_HEIGHT_REM * (1 - percent) + "rem, 0)"
        };
    };
    dmx108_dataApi.setElectricHandler($scope.volume_updateElectric);

    $scope.volume_onClick_rangeUp = function (index) {
        var volume = $scope.volume_list[index];
        volume.volumeIndex = Math.min(Math.max(0, volume.volumeIndex + 1), volume.list.length - 1);
        dmx108_dataApi.setVolumeIndex(index, volume.volumeIndex);
        volume.updateRange();
    };
    $scope.volume_onClick_rangeDown = function (index) {
        var volume = $scope.volume_list[index];
        volume.volumeIndex = Math.min(Math.max(0, volume.volumeIndex - 1), volume.list.length - 1);
        dmx108_dataApi.setVolumeIndex(index, volume.volumeIndex);
        volume.updateRange();
    };
    $scope.volume_onChange_range = function (index) {
        var volume = $scope.volume_list[index];
        volume.volumeIndex = parseInt(volume.volumeIndex);
        dmx108_dataApi.setVolumeIndex(index, volume.volumeIndex);
        volume.updateRange();
    };
    $scope.volume_onClick_mute = function (index) {
        var volume = $scope.volume_list[index];
        volume.isMute = !volume.isMute;
        dmx108_dataApi.setMute(index, volume.isMute);
    };
    $scope.volume_onClick_muteAll = function () {
        var loopLength = $scope.volume_list.length / 2;
        var loopStartIndex = $scope.volume_isCurInput ? 0 : loopLength;
        for (var i = 0; i < loopLength; ++i) {
            var index = loopStartIndex + i;
            var item = $scope.volume_list[index];
            item.isMute = true;
            dmx108_dataApi.setMute(index, true);
            // console.log(" ================== index=" + index);
        }
    };
    $scope.volume_onClick_volumnNum = function (index) {
        navigator.notification.prompt(dmx108_ui.VOLUME_SET_CHANNEL_NUM, function (res) {
            if (res.buttonIndex == 1) {
                $scope.modifyChannelValue(index, res.input1);
            }
        }, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
    };
    $scope.volume_onClick_channelName = function (index) {
        navigator.notification.prompt(dmx108_ui.VOLUME_SET_CHANNEL_NAME, function (res) {
            if (res.buttonIndex == 1) {
                $scope.modifyChannelName(index, res.input1);
            }
        }, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
    };

    // ===============================================================================
    // ========== 混音界面 ==========================================================
    // ===============================================================================

    $scope.mix_curOutIndex = 0;
    $scope.mix_updateData = function () {
        $scope.mix_outList_2d = dmx108_dataApi.getMixOutList_2d();
        $scope.mix_curOutIndex = Math.min(Math.max(0, $scope.mix_curOutIndex), $scope.mix_outList_2d.length - 1);

        $scope.mix_inNameList_8CH = ["IN1", "IN2", "IN3", "IN4", "IN5", "IN6", "IN7", "IN8", "AutoMixer", "Ducker"];
        $scope.mix_inNameList_16CH = ["IN1", "IN2", "IN3", "IN4", "IN5", "IN6", "IN7", "IN8", "IN9", "IN10", "IN11", "IN12", "IN13", "IN14", "IN15", "IN16", "AutoMixer", "Ducker", "AFC1", "AFC2", "AFC3", "AFC4", "AEC"];
        $scope.mix_inNameList = $scope.mix_outList_2d[0].length > $scope.mix_inNameList_8CH.length ? $scope.mix_inNameList_16CH : $scope.mix_inNameList_8CH;

        $scope.mix_onClick_out = function (index) {
            $scope.mix_curOutIndex = index;
        };
        $scope.mix_onClick_in = function (index) {
            var curOut = $scope.mix_outList_2d[$scope.mix_curOutIndex];
            curOut[index] = !curOut[index];
            dmx108_dataApi.setMixItem(index, $scope.mix_curOutIndex, curOut[index]);
        };
    };
    $scope.mix_updateData();

    // ===============================================================================
    // ========== 设置界面 ==========================================================
    // ===============================================================================

    $scope.setting_updateData = function () {
        //自动登录信息存在机器上，而不是APP浏览器存储
        $scope.setting_autoLogin = dmx108_dataApi.getAutoLogin();
        $scope.setting_onClick_autoLogin = function () {
            $scope.setting_autoLogin = !$scope.setting_autoLogin;
            dmx108_dataApi.setAutoLogin($scope.setting_autoLogin);
        };
    };

    $scope.setting_onClick_appVersion = function () {};
    $scope.setting_onClick_language = function () {
        $scope.system_setLanguage(!$scope.system_isEnglish);
        $scope.volume_updateData();
        $scope.tab_updateData();
    };
    $scope.setting_onClick_password = function () {
        var promptCallback = function promptCallback(result) {
            var selectIndex = result.buttonIndex;
            if (selectIndex != 1) {
                return;
            }
            var password = result.input1.trim();
            $scope.modifyPassword(password);
        };
        navigator.notification.prompt(dmx108_ui.PROMPT_INPUT_NEW_PASSWORD, promptCallback, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
    };
    $scope.setting_onClick_logo = function () {};

    $scope.setting_onClick_mix = function () {
        if (dmx108_data.getUserLoginInfo().id == 1 || !$scope.device_isOnline) {
            $scope.menu_onClick_item($scope.tab_enum_mix);
        }
    };
    $scope.setting_onClick_deviceName = function () {
        navigator.notification.prompt(dmx108_ui.PROMPT_INPUT_DEVICE_NAME, function (res) {
            if (res.buttonIndex == 1) {
                $scope.modifyDeviceName(res.input1);
            }
        }, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
    };
    $scope.setting_onClick_skin = function () {};

    // =================================================================================================
    // ======= 场景页面逻辑 ====================================================================
    // =================================================================================================
    /**
     * 加载场景
     * @{场景Id}sceneNo 
     */
    $scope.__tmpSceneNo = 0;
    $scope.loadScene = function (sceneNo) {
        window.plugins.spinnerDialog.show('', dmx108_ui.PROMPT_SCENE_LOADING, true);
        setTimeout(function () {
            window.plugins.spinnerDialog.hide();
        }, 5000);
        $scope.__tmpSceneNo = sceneNo;
        SocketManager.sendData(dmx108_protocol.getLoadProgramPro(sceneNo));
    },

    // =================================================================================================
    // ======= 设备页面逻辑 ====================================================================
    // =================================================================================================
    // 搜索设备
    $scope.searchDevice = function () {
        window.plugins.spinnerDialog.show('', dmx108_ui.PROMPT_DEVICE_SEARCHING, true);
        TcpManger.searchDevice(function () {
            console.log(DeviceManager.getDeviceList());
            window.plugins.spinnerDialog.hide();
            $scope.device_updateData();
            $scope.$apply();
            // if (DeviceManager.getDeviceList().length > 0) {
            //     let device = DeviceManager.getDeviceList()[0]
            //     that.connectSocket(device.ip)
            // }
        }, function () {
            console.log('search device fail');
            window.plugins.spinnerDialog.hide();
        });
    };

    // 修改通道值
    $scope.modifyChannelValue = function (index, value) {
        var val = parseFloat(value);
        if (isNaN(val) || val < -72 || val > 12) {
            window.plugins.toast.showShortCenter(dmx108_ui.VOLUME_VAL_INPUT_INVALID);
            return;
        }
        var valIndex = (val - -72) * 10;
        dmx108_dataApi.setVolumeIndex(index, valIndex);
        $scope.volume_updateData();
        $scope.$apply();
    },

    // 修改通道名
    $scope.modifyChannelName = function (index, name) {
        if (name.length <= 0) {
            window.plugins.toast.showShortCenter(dmx108_ui.VOLUME_NAME_CANNOT_EMPTY);
            return;
        }
        var bytes = util.getBytesByMixString(name);
        if (bytes.length > 10) {
            window.plugins.toast.showShortCenter(dmx108_ui.VOLUME_NAME_LEN_LIMIT);
            return;
        }
        dmx108_dataApi.setChannelName(index, bytes);
        $scope.volume_updateData();
        $scope.$apply();
    };

    // 修改用户密码
    $scope.modifyPassword = function (password) {
        var bytes = util.getBytesByMixString(password);
        if (bytes.length != password.length) {
            window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_PASSWORD_CANNOT_CONTAIN_CHINESE);
            return;
        } else if (bytes.length > 16) {
            window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_PASSWORD_CAN_NOT_EXCEED_16);
            return;
        }
        window.plugins.spinnerDialog.show("", dmx108_ui.PROMPT_MODIFY_ING, true);
        dmx108_dataApi.modifyPassword(bytes);
        setTimeout(function () {
            window.plugins.spinnerDialog.hide();
        }, 5000);
    },

    // 用户退出登录
    $scope.userLogout = function () {
        if (!$scope.device_isOnline) {
            window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_DEVICE_NOT_CONNECTED);
            return;
        }
        SocketManager.sendData(dmx108_protocol.getUserLogoutPro(dmx108_data.getUserLoginInfo().id));
    }, $scope.lastHeartbeatTime = 0; // 最后一次心跳时间
    // 连接socket
    $scope.connectSocket = function (ip, index) {
        window.plugins.spinnerDialog.show('', dmx108_ui.PROMPT_DEVICE_CONNECTING, true);
        var that = this;
        var addConnectSuccListener = function addConnectSuccListener() {
            SocketManager.addSocketConnectEvent(function () {
                console.log("aaa socket connect succ");
            });
            SocketManager.addSocketDisconnectEvent(function () {
                console.log("aaa socket disconnect");
                $scope.device_isOnline = false;
                that.stopHearbeat();
                window.plugins.spinnerDialog.hide();
                $scope.$apply();
            });
            SocketManager.subscribeRecvData(function (data) {
                $scope.handleRecvData(data, index);
            }, function (data) {
                // 收到非法数据
                $scope.lastHeartbeatTime = new Date().getTime();
                // console.log('heart beart ' + (that.lastHeartbeatTime / 1000))
            });
        };
        SocketManager.connectSocket(ip, 6000, function () {
            console.log("aaa connect ok");
            addConnectSuccListener();
            that.connectDevice();
        }, function () {
            console.log("aaa connect fail");
            window.plugins.spinnerDialog.hide();
        });
    };

    // 连接设备
    $scope.connectDevice = function () {
        SocketManager.sendData(dmx108_protocol.getDisconnectDevicePro());
        setTimeout(function () {
            SocketManager.sendData(dmx108_protocol.getConnectDevicePro());
        }, 1000);
        setTimeout(function () {
            if (!$scope.device_isOnline) {
                window.plugins.spinnerDialog.hide();
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_DEVICE_CONNECT_FAIL);
            }
        }, 10000);
    };

    // 断开设备连接
    $scope.disconnectDevice = function () {
        window.plugins.spinnerDialog.show('', dmx108_ui.PROMPT_DEVICE_DISCONNECTING, true);
        SocketManager.sendData(dmx108_protocol.getDisconnectDevicePro());
        setTimeout(function () {
            console.log('disconnectSocket 2');
            SocketManager.disconnectSocket();
            window.plugins.spinnerDialog.hide();
            window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_DEVICE_DISCONNECTED);
            // 更新数据
            $scope.device_updateData();
            $scope.device_isOnline = false;
            $scope.device_list[$scope.curConnectDeviceIndex].state = 0;
            $scope.$apply();
        }, 1000);
    };

    $scope.modifyDeviceName = function (newName) {
        if (newName.length <= 0) {
            window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_NAME_CAN_NOT_EMPTY);
        }
        var bytes = util.getBytesByMixString(newName);
        if (bytes.length > 20) {
            window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_NAME_CAN_NOT_EXCEED_10);
        } else {
            var tail = 20 - bytes.length;
            for (var i = 0; i < tail; i++) {
                bytes.push(0x00);
            }
            SocketManager.sendData(dmx108_protocol.getModigyDeviceNamePro(bytes));
        }
    }, $scope.hearbeatHandler = undefined;
    $scope.electrictRefreshHandler = undefined; // 刷新电平
    $scope.startHeartbeat = function () {
        var that = this;
        this.stopHearbeat();
        console.log('start heartbeat');
        var heartCallback = function heartCallback() {
            var curTime = new Date().getTime();
            if (that.lastHeartbeatTime > 0 && curTime - that.lastHeartbeatTime > 15000) {
                console.log('disconnectSocket 1');
                SocketManager.disconnectSocket();
                that.stopHearbeat();
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_DEVICE_DISCONNECTED);
            } else {
                SocketManager.sendData(dmx108_protocol.getSearchDevicePro(), function () {
                    // console.log('send succ')
                }, function () {
                    // console.log('send fail')
                });
            }
            that.hearbeatHandler = setTimeout(heartCallback, 4000);
        };
        this.hearbeatHandler = setTimeout(heartCallback, 4000);
        var electricCallback = function electricCallback() {
            if ($scope.tab_curEnum == $scope.tab_enum_volume) {
                SocketManager.sendData(dmx108_protocol.getReadElectricPro());
            }
            that.electrictRefreshHandler = setTimeout(electricCallback, 150);
        };
        this.electrictRefreshHandler = setTimeout(electricCallback, 150);
    };

    $scope.stopHearbeat = function () {
        console.log('stop heartbeat');
        if (this.hearbeatHandler != undefined) {
            clearTimeout(this.hearbeatHandler);
        }
        if (this.electrictRefreshHandler != undefined) {
            clearTimeout(this.electrictRefreshHandler);
        }
    };

    /**
     * 读取程式数据
     */
    $scope.readProgramData = function (programNo) {
        SocketManager.sendData(dmx108_protocol.getReadProgramDataPro(programNo));
    };

    /**
     * 读取通道数据
     */
    $scope.readCurSceneInChannelData = function (channel) {
        var divid = $scope.device_channelNum_is8Ch ? 8 : 16;
        if (channel < divid) {
            SocketManager.sendData(dmx108_protocol.getInChannelDataPro(0, channel));
        } else {
            SocketManager.sendData(dmx108_protocol.getOutChannelDataPro(0, 0x10 + (channel - divid)));
        }
    };

    /**
     * 查询用户数量
     */
    $scope.getUserNum = function () {
        SocketManager.sendData(dmx108_protocol.getUserNumPro());
    },

    /**
     * 获取用户信息列表
     */
    $scope.getUserInfoList = function (id) {
        SocketManager.sendData(dmx108_protocol.getUserInfoPro(id));
    },

    /**
     * 查询用户登录情况
     */
    $scope.getUserLoginInfo = function () {
        SocketManager.sendData(dmx108_protocol.getUserLoginInfoPro());
    },

    /**
     * 检查用户登录状态
     */
    $scope.checkUserLoginStatus = function () {
        if (!dmx108_data.getUserLoginInfo().isLogin) {
            var userInfoList = dmx108_data.getUserInfoList();
            var uiList = [];
            for (var i = 0; i < userInfoList.length; i++) {
                var item = '';
                item += userInfoList[i].id;
                item += ' : ';
                item += userInfoList[i].userName;
                uiList.push(item);
            }
            var options = {
                androidTheme: window.plugins.actionsheet.ANDROID_THEMES.THEME_DEVICE_DEFAULT_DARK, // default is THEME_TRADITIONAL
                buttonLabels: uiList,
                title: dmx108_ui.PROMPT_CHOOSE_ACCOUNT,
                androidEnableCancelButton: false, // default false
                addCancelButtonWithLabel: dmx108_ui.PROMPT_CANCEL,
                position: [20, 40], // for iPad pass in the [x, y] position of the popover
                destructiveButtonLast: true // you can choose where the destructive button is shown
            };
            window.plugins.actionsheet.show(options, function (buttonIndex) {
                if (buttonIndex > userInfoList.length) {
                    console.log('disconnectDevice 1');
                    $scope.disconnectDevice();
                    return;
                };
                var userInfo = userInfoList[buttonIndex - 1];
                var promptCallback = function promptCallback(result) {
                    console.log('...');
                    console.log(result);
                    var selectIndex = result.buttonIndex;
                    if (selectIndex != 1) {
                        console.log('disconnectDevice 2');
                        $scope.disconnectDevice();
                        return;
                    }
                    var password = result.input1;
                    var bytes = util.getBytesByMixString(password);
                    if (bytes.length != password.length) {
                        window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_PASSWORD_CANNOT_CONTAIN_CHINESE);
                        return;
                    }
                    window.plugins.spinnerDialog.show("", dmx108_ui.PROMPT_LOGIN_ING, true);
                    dmx108_dataApi.login(userInfo.id, bytes);
                    setTimeout(function () {
                        window.plugins.spinnerDialog.hide();
                    }, 5000);
                };
                navigator.notification.prompt(dmx108_ui.PROMPT_INPUT_PASSWORD, promptCallback, dmx108_ui.PROMPT_TITLE, [dmx108_ui.PROMPT_CONFIRM, dmx108_ui.PROMPT_CANCEL]);
            });
        }
    },

    // ============= socket 数据 接收 ==========================
    $scope.curConnectDeviceIndex = -1, // 当前连接的设备id
    $scope.handleRecvData = function (data, index) {
        $scope.curConnectDeviceIndex = index;
        var that = this;
        // console.log('heart beart ' + (that.lastHeartbeatTime / 1000))
        that.lastHeartbeatTime = new Date().getTime();
        // console.log("aaa recv data: " + util.bytesToString(data))
        if (data[5] == 0x02) {
            // 联机应答
            // 设置当前场景信息
            var sceneInfo = dmx108_data.getCurSceneInfo();
            sceneInfo.id = data[12];
            dmx108_data.setCurSceneInfo(sceneInfo);
            // 读取输入通道数据
            dmx108_data.resetChannelList();
            $scope.readCurSceneInChannelData(0);
        } else if (data[5] == 0xE2) {
            // 输入通道数据应答
            // 保存通道数据
            dmx108_data.addChannelInfo(data);

            var channelNum = $scope.device_channelNum_is8Ch ? 8 : 16;
            if (data[8] < channelNum - 1) {
                $scope.readCurSceneInChannelData(data[8] + 1);
            } else {
                console.log('read in channel ok');
                // 读取输出通道数据
                $scope.readCurSceneInChannelData(channelNum);
            }
        } else if (data[5] == 0xE4) {
            // 输出通道数据应答
            // 保存通道数据
            dmx108_data.addChannelInfo(data);

            var _channelNum = $scope.device_channelNum_is8Ch ? 8 : 16;
            var outIndex = data[8] - 0x10;
            if (outIndex < _channelNum - 1) {
                $scope.readCurSceneInChannelData(_channelNum + outIndex + 1);
            } else {
                console.log('read out channel ok');
                dmx108_data.setUserCount(0);
                dmx108_data.resetUserInfoList();
                dmx108_data.setUserLoginInfo({});
                $scope.getUserNum();
            }
        } else if (data[5] == 0x8A) {
            // 用户模块应答 
            if (data[7] == 0x05) {
                // 查询用户数应答
                dmx108_data.setUserCount(data[8]);
                $scope.getUserInfoList(0);
            } else if (data[7] == 0x06) {
                // 查询用户信息应答
                var userInfo = {};
                userInfo.seq = data[8];
                userInfo.type = data[9];
                userInfo.id = data[10];
                userInfo.autoLogin = data[28];
                userInfo.userName = util.getMixStringByBytes(data.slice(12, 12 + data[11]));
                dmx108_data.addUserInfo(userInfo);
                if (data[8] < dmx108_data.getUserCount() - 1) {
                    $scope.getUserInfoList(data[8] + 1);
                } else {
                    $scope.getUserLoginInfo();
                }
            } else if (data[7] == 0x08) {
                // 退出登录应答
                if (data[8] == 0) {
                    window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_QUIT_ACCOUNT_FAIL);
                } else {
                    window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_QUIT_ACCOUNT_SUCC);
                    console.log('disconnectDevice 3');
                    $scope.disconnectDevice();
                }
            } else if (data[7] == 0x09) {
                // 查询登录情况
                var userLoginInfo = {};
                userLoginInfo.isLogin = data[8];
                userLoginInfo.type = data[9];
                userLoginInfo.id = data[10];
                dmx108_data.setUserLoginInfo(userLoginInfo);
                console.log('read user info ok');
                console.log(dmx108_data.__userInfoList);
                console.log(dmx108_data.__userLoginInfo);
                // 读取程式数据
                dmx108_data.resetProgramDataList();
                that.readProgramData(0); // 读取程式数据
            } else if (data[7] == 0x0B) {
                // 设置自动登录应答
                if (data[8] == 0) {
                    window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_SET_AUTO_LOGIN_FAIL);
                } else {
                    var curUserInfo = dmx108_data.getUserLoginInfo();
                    var userInfoList = dmx108_data.getUserInfoList();
                    for (var tmp_i = 0; tmp_i < userInfoList.length; tmp_i++) {
                        var item = userInfoList[tmp_i];
                        if (curUserInfo != undefined && curUserInfo.id == item.id) {
                            dmx108_data.__userInfoList[tmp_i].autoLogin = 1;
                        }
                    }
                    $scope.$apply();
                }
            } else if (data[7] == 0x07) {
                // 登录应答
                window.plugins.spinnerDialog.hide();
                if (data[8] == 0) {
                    window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_LOGIN_FAIL);
                    console.log('disconnectDevice 4');
                    $scope.disconnectDevice();
                } else {
                    window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_LOGIN_SUCC);
                    dmx108_data.__userLoginInfo.id = data[8];
                    dmx108_data.__userLoginInfo.isLogin = 1;
                    $scope.device_updateData();
                    $scope.$apply();
                }
            } else if (data[7] == 0x02) {
                // 修改用户名
                if (data[8] == 0) {
                    window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_MODIFY_FAIL);
                } else {
                    window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_MODIFY_SUCC);
                }
                window.plugins.spinnerDialog.hide();
            }
        } else if (data[5] == 0xE0) {
            // 程式数据应答
            console.log('read program data ' + data[7]);
            var programNo = data[7];
            if (programNo == 0) {
                // 当前场景，设置一下场景名
                var curProgramData = data;
                var curProgramName = util.getMixStringByBytes(curProgramData.slice(9, 29));
                var curProgramInfo = dmx108_data.getCurSceneInfo();
                curProgramInfo.name = curProgramName;
                dmx108_data.setCurSceneInfo(curProgramInfo);
            }
            dmx108_data.addProgramData(data);
            if (programNo < 30) {
                that.readProgramData(programNo + 1); // 获取下一个程式数据
            } else {
                console.log('read program data list succ');
                window.plugins.spinnerDialog.hide();
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_FINISH_READ_DATA);
                // 更新数据
                $scope.device_updateData();
                $scope.device_isOnline = true;
                $scope.device_list[index].state = 1;
                $scope.scene_updateData();
                $scope.volume_updateData();
                $scope.setting_updateData();
                $scope.mix_updateData();
                // 启动心跳
                that.startHeartbeat();
                // 检查用户登录
                $scope.checkUserLoginStatus();
                // 刷新界面
                $scope.$apply();
            }
        } else if (data[5] == 0x62) {
            // 加载场景应答
            if (data[7] == 1) {
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_SCENE_LOAD_SUCC);
                // 更新场景ID
                var _sceneInfo = dmx108_data.getCurSceneInfo();
                _sceneInfo.id = $scope.__tmpSceneNo;
                dmx108_data.setCurSceneInfo(_sceneInfo);
                // 读取输入通道数据
                dmx108_data.resetChannelList();
                $scope.readCurSceneInChannelData(0);
            } else {
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_SCENE_LOAD_FAIL);
            }
        } else if (data[5] == 0xA0) {
            // 读取电平应答
            if (data[6] == 16) {
                for (var i = 0; i < 16; i++) {
                    dmx108_dataApi.notifyElectric(i, data[7 + i] / 72);
                }
            } else if (data[6] == 32) {
                for (var _i = 0; _i < 32; _i++) {
                    dmx108_dataApi.notifyElectric(_i, data[7 + _i] / 72);
                }
            }
            $scope.$apply();
        } else if (data[5] == 0x11) {
            // 修改设备名字
            if (data[7] == 1) {
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_MODIFY_SUCC);
            } else {
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_MODIFY_FAIL);
            }
            window.plugins.spinnerDialog.hide();
        } else if (data[5] == 0x12) {
            // 修改通道名
            if (data[7] == 1) {
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_MODIFY_SUCC);
            } else {
                window.plugins.toast.showShortCenter(dmx108_ui.PROMPT_MODIFY_FAIL);
            }
            window.plugins.spinnerDialog.hide();
        }
    };
});