'use strict';

/**
 * 数据缓存模块
 */
var dmx108_data = {
    // 当前程式号1-30
    __curSceneInfo: {
        id: 1,
        name: ''
    },

    // 程式数据列表，0-30个数组
    __programDataList: [],

    // 获取用户信息
    __userInfo: {
        // TODO
    },

    // 输入通道数据 [[]]  // 二维数组，IN在前面，OUT在后面
    __channelInfoList: [],

    // 用户信息
    __userCount: 0, // 用户数
    __userInfoList: [], // 用户信息列表 [{seq:0, type:0, id:0, userName:'', autoLogin:0}]
    __userLoginInfo: {}, // 当前用户登陆情况 {type:0, id:0, isLogin:0}

    /**
     * 初始化数据
     */
    init: function init() {
        for (var i = 0; i < 16; i++) {
            var data = [];
            for (var j = 0; j < 100; j++) {
                data.push(0);
            }
            this.__channelInfoList.push(data);
        }
    },

    // =================================================================================
    // =================================================================================

    /**
     * 获取程式数据列表
     */
    getProgramDataList: function getProgramDataList() {
        return this.__programDataList;
    },

    /**
     * 获取程式数据
     */
    getProgramData: function getProgramData(index) {
        return this.__programDataList[index];
    },

    /**
     * 添加程式数据
     */
    addProgramData: function addProgramData(programData) {
        this.__programDataList.push(programData);
    },

    /**
     * 重置程式数据数组
     */
    resetProgramDataList: function resetProgramDataList() {
        this.__programDataList = [];
    },

    /**
     * 获取当前场景信息
     */
    getCurSceneInfo: function getCurSceneInfo() {
        return this.__curSceneInfo;
    },

    /**
     * 设置当前场景信息
     */
    setCurSceneInfo: function setCurSceneInfo(sceneInfo) {
        this.__curSceneInfo = sceneInfo;
    },

    /**
     * 获取通道数据列表
     */
    getChannelList: function getChannelList() {
        return this.__channelInfoList;
    },

    /**
     * 获取通道数据
     */
    getChannelInfo: function getChannelInfo(index) {
        return this.__channelInfoList[index];
    },

    /**
     * 添加通道数据
     */
    addChannelInfo: function addChannelInfo(channelInfo) {
        this.__channelInfoList.push(channelInfo);
    },

    /**
     * 重置通道数据列表
     */
    resetChannelList: function resetChannelList() {
        this.__channelInfoList = [];
    },

    /**
     * 设置用户数
     */
    setUserCount: function setUserCount(count) {
        this.__userCount = count;
    },

    /**
     * 获取用户数
     */
    getUserCount: function getUserCount() {
        return this.__userCount;
    },

    /**
     * 获取用户信息列表
     */
    getUserInfoList: function getUserInfoList() {
        return this.__userInfoList;
    },

    /**
     * 重置用户信息列表
     */
    resetUserInfoList: function resetUserInfoList() {
        this.__userInfoList = [];
    },

    /**
     * 添加用户信息
     */
    addUserInfo: function addUserInfo(userInfo) {
        this.__userInfoList.push(userInfo);
    },

    /**
     * 获取用户登陆情况
     */
    getUserLoginInfo: function getUserLoginInfo() {
        return this.__userLoginInfo;
    },

    /**
     * 设置用户登陆情况
     */
    setUserLoginInfo: function setUserLoginInfo(loginInfo) {
        this.__userLoginInfo = loginInfo;
    }
};